require "objc2swift_assistant/version"

require "objc2swift_assistant/code_recognizer"

module Objc2swiftAssistant

  class ImplementationRecognizer < CodeRecognizer
    def initialize( )
      super( /^\s*@implementation/, ImplementationRegion, :implementation, true )
    end
  end


  class ImplementationRegion < ClassRootRegion

    def initialize(starting_line_number, is_root_entity )
      super(starting_line_number, is_root_entity, CLASS_IMPLEMENTATION_KEY )
    end

    def extract_information( file_slice )
      class_name_match = /^\s*(@implementation)\s+(?<class_name>\w*)/.match(file_slice[0])
      unless class_name_match.nil?
        @class_name = class_name_match["class_name"]
      else
        @configuation.log_warning( "Could not match class name in #{file_slice[0]}" )
      end
    end

  end

end