require "objc2swift_assistant/version"

require "objc2swift_assistant/code_recognizer"

module Objc2swiftAssistant

  class ProtocolRecognizer < CodeRecognizer
    def initialize( )
      super( /^\s*@protocol()/, ProtocolRegion, :implementation, true, voiding_regex:/^\s*@interface\s*\w*\s*\(/)
    end
  end


  class ProtocolRegion < MigrationRegion
    attr_accessor :protocol_name
    attr_accessor :extends

    def initialize(starting_line_number, is_root_entity )
      super(starting_line_number, is_root_entity, PROTOCOL_DECLARATION_KEY )
    end

    def extract_information( file_slice )
      m = /^\s*(@protocol)\s+(?<protocol_name>\w*)\s*(<(?<extends>.*)>)?/.match(file_slice[0])
      unless m.nil?
        @protocol_name = m["protocol_name"]
        extends_list = m["extends"]
        @extends = extends.nil? ? [] : extends_list.split( /\s*,\s*/ )
        @configuration.log_verbose( "class_name = #{@protocol_name} extends = #{@extends}")
      else
        @configuration.log_warning( "Could not match protocol declaration in #{file_slice[0]}" )
      end
    end

    def description()
      generic_description( "Protocol: #{@protocol_name}" )
    end

  end

end
